package com.gymtracker.util;

import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPMessage;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPMessageContext;
import java.lang.reflect.Method;
import java.net.InetSocketAddress;
import java.net.URI;
import java.sql.Timestamp;
import java.util.Arrays;
import java.util.Calendar;
import java.util.stream.Collectors;

public class Util {
    public static String getIP(MessageContext mc) {
        try {
            Class<?> clazz = mc.get("com.sun.xml.internal.ws.http.exchange").getClass();
            Method method = clazz.getDeclaredMethod("getRemoteAddress");
            method.setAccessible(true);

            InetSocketAddress address = (InetSocketAddress) method
                    .invoke(mc.get("com.sun.xml.internal.ws.http.exchange"));
            return address.getAddress().getHostAddress();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        return "";
    }

    public static String getURL(MessageContext mc) {
        try {
            Class<?> clazz = mc.get("com.sun.xml.internal.ws.http.exchange").getClass();
            Method method = clazz.getDeclaredMethod("getRequestURI");
            method.setAccessible(true);

            URI uri = (URI) method.invoke(mc.get("com.sun.xml.internal.ws.http.exchange"));
            return uri.toString();
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
    }

    public static String formatContentBody(SOAPMessageContext smc) {
        try {
            SOAPMessage soapMessage = smc.getMessage();
            SOAPBody soapBody = soapMessage.getSOAPBody();
            String bodyContent = soapBody.getTextContent();

            String[] lines = bodyContent.split("\\n");
            // Filter out empty lines and remove leading whitespaces
            return Arrays.stream(lines)
                    .map(String::trim)
                    .filter(s -> !s.isEmpty())
                    .collect(Collectors.joining(",\n"));
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
    }

    public static Timestamp toUTCSeven(Timestamp timestamp) {
        try {
            Calendar calendar = Calendar.getInstance();
            calendar.setTimeInMillis(timestamp.getTime());
            calendar.add(Calendar.HOUR_OF_DAY, 7);
            return new Timestamp(calendar.getTimeInMillis());
        } catch (Exception e) {
            e.printStackTrace();
            return new Timestamp(System.currentTimeMillis());
        }
    }
}
